/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cart;

import entity.Product;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author User
 */
public class ShoppingCartTest {
    
    public ShoppingCartTest() {
    }
    
    @BeforeClass
    public static void setUpClass() {
    }
    
    @AfterClass
    public static void tearDownClass() {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    /**
     * Test of addItem method, of class ShoppingCart.
     */
    @Test
    public void testAddingOneAppleToCartGivesOneShoppingCartItem() {
        // given
        Product apple = new Product(1, "Green Apple", BigDecimal.ZERO, new Date());
        ShoppingCart cart = new ShoppingCart();
        
        // when
        cart.addItem(apple);
        
        // then
        int numOfItems = cart.getNumberOfItems();
        assertEquals("neocekivan broj proizvoda u korpi", 1, numOfItems);
        List<ShoppingCartItem> items = cart.getItems();
        ShoppingCartItem appleItem = items.get(0);
        assertEquals(apple, appleItem.getProduct());
    }
    
    
    @Test
    public void testAddingOneAppleToCartGivesQuanityOne() {
        // given
        Product apple = new Product(1, "Green Apple", BigDecimal.ZERO, new Date());
        ShoppingCart cart = new ShoppingCart();
        
        // when
        cart.addItem(apple);
        
        // then
        int numOfItems = cart.getNumberOfItems();
        assertEquals("neocekivan broj proizvoda u korpi", 1, numOfItems);
        List<ShoppingCartItem> items = cart.getItems();
        ShoppingCartItem appleItem = items.get(0);
        assertEquals(1, appleItem.getQuantity());
    }
    
    /**
     * Test of addItem method, of class ShoppingCart.
     */
    @Test
    public void testAddingTwoItemsGivesQuantityTwo() {
        // given
        Product product = new Product(null, "Product Number 2", BigDecimal.ZERO, new Date());
        ShoppingCart cart = new ShoppingCart();
        
        // when
        cart.addItem(product);
        cart.addItem(product);
        
        // then
        int numOfItems = cart.getNumberOfItems();
        assertEquals("neocekivan broj proizvoda u korpi", 2, numOfItems);
        
    }
    
    /**
     * Test of update method, of class ShoppingCart.
     */
    @Test
    public void testUpdateCartWithNewItem() {
        // given
        Product milk = new Product(1, "Chocolate milk", BigDecimal.ZERO, new Date());
        ShoppingCart cart = new ShoppingCart();
        cart.addItem(milk);
        
        // when
        cart.update(milk, "0");
        // then
        int numOfItems = cart.getNumberOfItems();
        assertEquals("neocekivan sadrzaj korpe", 0, numOfItems);
        
    }
    
    /**
     * Test of update method, of class ShoppingCart.
     */
    @Test
    public void testUpdatingAppleQuantityToThree() {
        // given
        Product apple = new Product(1, "Red Apple", new BigDecimal(250), new Date());
        Product milk = new Product(2, "Milk", new BigDecimal(300), new Date());
        ShoppingCart cart = new ShoppingCart();
        cart.addItem(apple); // 1 jabuka
        cart.addItem(milk);// 2 mleka
        cart.addItem(milk);
        
        // when 
        cart.update(apple, "3");
        
        // then
        for (ShoppingCartItem item : cart.getItems()) {
            // trazi se item koji odgovara jabucii
            if (item.getProduct().equals(apple)) {
                assertEquals("neocekivana kolicina jabuka u korpi", 3, item.getQuantity());
                return;
            }
        }
        fail("Nije pronadjen item u cartu koji odgovara jabuci");
    }
    
    /**
     * Test of update method, of class ShoppingCart.
     */
    @Test
    public void testUpdatingAppleQuantityToZero() {
        // given
        Product apple = new Product(1, "Red Apple", new BigDecimal(250), new Date());
        ShoppingCart cart = new ShoppingCart();
        cart.addItem(apple); // 1 jabuka
        
        // when 
        cart.update(apple, "0"); // upldate cart
        
        // then
        for (ShoppingCartItem item : cart.getItems()) {
            // trazi se item koji odgovara jabuci
            if (item.getProduct().equals(apple)) {
                fail("Neocekivano smo pronasli jabuku u korpi");
                return;
            }
        }
        assertTrue(true);
    }
    
    /**
     * Test of update method, of class ShoppingCart.
     */
    @Test
    public void testUpdatingAppleQuantityMultipleTimes() {
        // given
        Product apple = new Product(1, "Green Apple", new BigDecimal(250), new Date());
        ShoppingCart cart = new ShoppingCart();
        cart.addItem(apple); // 1 jabuka
        
        // when 
        cart.update(apple, "3");
        cart.update(apple, "7");
        
        // then
        for (ShoppingCartItem item : cart.getItems()) {
            // trazi se item koji odgovara jabuci
            if (item.getProduct().equals(apple)) {
                assertEquals("neocekivana kolicina jabuka u korpi", 7, item.getQuantity());
                return;
            }
        }
        fail("Nije pronadjen item u cartu koji odgovara jabuci");

    }

    /**
     * Test of getNumberOfItems method, of class ShoppingCart.
     */
    @Test
    public void testGettingNumberOfItemsCorrect() {
        //given
        System.out.println("getNumberOfItems");
        ShoppingCart cart = new ShoppingCart();
        int expResult = 0;
        //when
        int result = cart.getNumberOfItems();
        //then
        assertEquals("neocekivan broj itema u korpi", expResult, result);

    }

    /**
     * Test of getSubtotal method, of class ShoppingCart.
     */
    @Test
    public void testEmptyCartGivesSubtotalOfZero() {
        // given
        ShoppingCart instance = new ShoppingCart();
        double expResult = 0.0;
        
        // when
        double result = instance.getSubtotal();
        
        // then
        assertEquals("zbir nije nula kao sto bi trebalo", expResult, result, 0.0);
    }
    
    /**
     * Test of getSubtotal method, of class ShoppingCart.
     */
    @Test
    public void testCartWithOneItemGivesCorrectSubtotal() {
        // given
        Product cake = new Product(333, "Strawberry cake", new BigDecimal(4040), new Date());
        ShoppingCart cart = new ShoppingCart();
        cart.addItem(cake);
        double expResult = 4040.0;
        // when
        double result = cart.getSubtotal();
        // then
        assertEquals("neocekivan medjurezultat", expResult, result, 0.0);

    }
    
    /**
     * Test of getSubtotal method, of class ShoppingCart.
     */
    @Test
    public void testCartWithThreeSameItemsGivesCorrectSubtotal() {
        // given
        Product chocolate = new Product(1, "White chocolate", new BigDecimal(4040), new Date());
        ShoppingCart cart = new ShoppingCart();
        cart.addItem(chocolate);
        cart.addItem(chocolate);
        cart.addItem(chocolate);
        double expResult = 12120.0;
        
        // when
        double result = cart.getSubtotal();
        
        // then
        assertEquals("neocekivan medjurezultat", expResult, result, 0.0);

    }
    
    /**
     * Test of getSubtotal method, of class ShoppingCart.
     */
    @Test
    public void testCartWithDifferentItemsGivesCorrectSubtotal() {
        // given
        Product meat = new Product(1, "Meat123", new BigDecimal(4040), new Date());
        Product fruit = new Product(2, "Fruit456", new BigDecimal(800), new Date());
        ShoppingCart cart = new ShoppingCart();
        cart.addItem(meat);
        cart.addItem(fruit);
        cart.addItem(fruit);
        double expResult = 5640.0;
        
        // when
        double result = cart.getSubtotal();
        
        // then
        assertEquals("neocekivan medjurezultat", expResult, result, 0.0);

    }

    /**
     * Test of calculateTotal    method, of class ShoppingCart.
     */
    @Test
    public void testCalculateTotalAfterClearMethod() {
        //given
        String surcharge = "1";
        ShoppingCart cart = new ShoppingCart();
        
        //when
        cart.calculateTotal(surcharge);
        cart.clear();

        //then
        double totalresult = cart.getTotal();
        assertEquals("Suma nije tacna", 0, totalresult, 0.0);

    }

    /**
     * Test of getTotal method, of class ShoppingCart.
     */
    @Test
    public void testGetTotal() {
        // given
        ShoppingCart cart = new ShoppingCart();
        String surcharge = "1";
        double subtotal;
        subtotal = cart.getSubtotal();
        
        // when
        cart.calculateTotal(surcharge);
        
        //then
        assertEquals("Suma nije tacna", 1, cart.getTotal(), 0.0);

    }

    /**
     * Test of clear method, of class ShoppingCart.
     */
    @Test
    public void testClear() {
        // given
        ShoppingCart cart = new ShoppingCart();
        List<ShoppingCartItem> items = cart.getItems();
        
        // when
        items.clear();
        
        //then
        int numOfItems = cart.getNumberOfItems();
        assertEquals("Broj proizvoda u korpi nije 0", 0, numOfItems);
        
    }
    
}