/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package filter;

import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.mockito.Mockito.*;

/**
 *
 * @author User
 */
public class SessionTimeoutFilterTest {
    
    public SessionTimeoutFilterTest() {
    }
    
    @BeforeClass
    public static void setUpClass() {
    }
    
    @AfterClass
    public static void tearDownClass() {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    /**
     * Test of doFilter method, of class SessionTimeoutFilter.
     */
    @Test
    public void testWhenNoSessionFilterRedirectsToIndex() throws Exception {
        System.out.println("doFilter");
        //given
        /// priprema zavisnih objekata - ovo su LAZNI objekti
        HttpServletRequest mockedRequest = mock(HttpServletRequest.class);
        when(mockedRequest.getSession(false)).thenReturn(null);
        HttpServletResponse mockedResponse = mock(HttpServletResponse.class);
        FilterChain mockedChain = mock(FilterChain.class);
        
        SessionTimeoutFilter instance = new SessionTimeoutFilter();
        //when
        instance.doFilter(mockedRequest, mockedResponse, mockedChain);
        
        //then
        verify(mockedRequest, times(1)).getRequestDispatcher("/index.jsp");
        verify(mockedChain, never()).doFilter(mockedRequest, mockedResponse);
    }
    
     @Test
    public void testWhenSessionExistsFilterContinuesChain() throws Exception {
        System.out.println("doFilter");
        //given
        /// priprema zavisnih objekata - ovo su LAZNI objekti
        HttpServletRequest mockedRequest = mock(HttpServletRequest.class);
        HttpSession mockedHttpSession = mock(HttpSession.class);
        when(mockedRequest.getSession(false)).thenReturn(mockedHttpSession);
        HttpServletResponse mockedResponse = mock(HttpServletResponse.class);
        FilterChain mockedChain = mock(FilterChain.class);
        
        SessionTimeoutFilter instance = new SessionTimeoutFilter();
        //when
        instance.doFilter(mockedRequest, mockedResponse, mockedChain);
        
        //then
        verify(mockedChain, times(1)).doFilter(mockedRequest, mockedResponse);
        verify(mockedRequest, never()).getRequestDispatcher("/index.jsp");
        
    }

    /**
     * Test of init method, of class SessionTimeoutFilter.
     */
    @Test
    public void testInit() throws Exception {
        System.out.println("init");
        FilterConfig filterConfig = null;
        SessionTimeoutFilter instance = new SessionTimeoutFilter();
        instance.init(filterConfig);

    }

    /**
     * Test of destroy method, of class SessionTimeoutFilter.
     */
    @Test
    public void testDestroy() {
        System.out.println("destroy");
        SessionTimeoutFilter instance = new SessionTimeoutFilter();
        instance.destroy();

    }
    
}
