/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package session;

import entity.Category;
import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ejb.embeddable.EJBContainer;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author User
 */
public class CategoryFacadeITArq {
    
    public CategoryFacadeITArq() {
    }
    
    @BeforeClass
    public static void setUpClass() {
    }
    
    @AfterClass
    public static void tearDownClass() {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    /**
     * Test of create method, of class CategoryFacade.
     */
    @Test
    public void testCreateAppleCategory() throws Exception {
        // given
        Category appleCategory = new Category();
        appleCategory.setName("Apples");
        EJBContainer container = javax.ejb.embeddable.EJBContainer.createEJBContainer();
        
        CategoryFacade instance = (CategoryFacade)container.getContext().lookup("java:global/classes/CategoryFacade");
        
        // when
        instance.create(appleCategory);

        // assert
        List<Category> allCategories = instance.findAll();
        boolean foundAppleCategory = false;
        for (Category category : allCategories) {
            if (category.getName().equals("Apples")) {
                foundAppleCategory = true;
                break;
            }
        }
        
        // clean up
        instance.remove(appleCategory);
        container.close();
        assertTrue("Nije pronadjena Apples kategorija", foundAppleCategory);
    }

    /**
     * Test of edit method, of class CategoryFacade.
     */
    @Test
    public void testEdit() throws Exception {
        System.out.println("edit");
        Category entity = null;
        EJBContainer container = javax.ejb.embeddable.EJBContainer.createEJBContainer();
        CategoryFacade instance = (CategoryFacade)container.getContext().lookup("java:global/classes/CategoryFacade");
        instance.edit(entity);
        container.close();

    }
    
    @Test
    public void testEditAppleCategory() throws Exception {
        // given
        Category appleCategory = new Category();
        appleCategory.setName("Apples");
        EJBContainer container = javax.ejb.embeddable.EJBContainer.createEJBContainer();
        CategoryFacade categoryFacade = (CategoryFacade)container.getContext().lookup("java:global/classes/CategoryFacade");
        categoryFacade.create(appleCategory);
        Short appleCategoryId = appleCategory.getId();
        System.err.println("id=" + appleCategoryId);
        
        // when
        Category foundCategory = categoryFacade.find(appleCategoryId);
        foundCategory.setName("NewApples");
        categoryFacade.edit(foundCategory);
        
        // assert
        Category editedAppleCategory = categoryFacade.find(appleCategoryId);
        assertEquals("NewApples", editedAppleCategory.getName());
        
        // clean up
        categoryFacade.remove(appleCategory);
        container.close();
    }

    /**
     * Test of remove method, of class CategoryFacade.
     */
    @Test
    public void testRemove() throws Exception {
        System.out.println("remove");
        Category entity = null;
        EJBContainer container = javax.ejb.embeddable.EJBContainer.createEJBContainer();
        CategoryFacade instance = (CategoryFacade)container.getContext().lookup("java:global/classes/CategoryFacade");
        instance.remove(entity);
        container.close();

    }
    
    @Test
    public void testRemoveAppleCategory() throws Exception {
        // given
        Category appleCategory = new Category();
        appleCategory.setName("Apples");
        // Create a properties map to pass to the embeddable container:
        EJBContainer container = javax.ejb.embeddable.EJBContainer.createEJBContainer();
        CategoryFacade categoryDAO = (CategoryFacade)container.getContext().lookup("java:global/classes/CategoryFacade");
        
        categoryDAO.create(appleCategory);
        
        // when
        categoryDAO.remove(appleCategory);
        
        
        // assert
        Category thisShouldNotExist = categoryDAO.find(appleCategory.getId());
        assertNull("Nije uklonjena Apples kategorija", thisShouldNotExist);
        
        // clean up
        categoryDAO.remove(appleCategory); // pomalo bez smisla jer je vec uklonjen gore
        container.close();
    }

    /**
     * Test of find method, of class CategoryFacade.
     */
    @Test
    public void testFindsOrangesCategory() throws Exception {
        System.out.println("find");
        // given
        Category orangesCategory = new Category();
        orangesCategory.setName("Oranges");
        
        EJBContainer container = javax.ejb.embeddable.EJBContainer.createEJBContainer();
        CategoryFacade categoryFacade = (CategoryFacade)container.getContext().lookup("java:global/classes/CategoryFacade");
        categoryFacade.create(orangesCategory);
        Short orangesCategoryId = orangesCategory.getId();
        
        // when
        Category found = categoryFacade.find(orangesCategoryId);
        
        // then
        assertNotNull(found);
        assertEquals(found.getName(), "Oranges");
        
        // clean up
        categoryFacade.remove(found);
        container.close();

    }

    /**
     * Test of findAll method, of class CategoryFacade.
     */
    @Test
    public void testFindAll() throws Exception {
        System.out.println("findAll");
        EJBContainer container = javax.ejb.embeddable.EJBContainer.createEJBContainer();
        CategoryFacade instance = (CategoryFacade)container.getContext().lookup("java:global/classes/CategoryFacade");
        List<Category> expResult = null;
        List<Category> result = instance.findAll();
        assertEquals(expResult, result);
        container.close();

    }

    /**
     * Test of findRange method, of class CategoryFacade.
     */
    @Test
    public void testFindRangeFrom2To4() throws Exception {
        // given
        
        EJBContainer container = javax.ejb.embeddable.EJBContainer.createEJBContainer();
        CategoryFacade categoryFacade = (CategoryFacade)container.getContext().lookup("java:global/classes/CategoryFacade");
        
        // ocisti sve kategorije
        // ovo moze u Before
        List<Category> allCategories = categoryFacade.findAll();
        for (Category category : allCategories) {
            categoryFacade.remove(category);
        }
        
        // kreiraj kategorije kontrolisano
                
        Category applesCategory = new Category();
        applesCategory.setName("Apples");
        Category orangesCategory = new Category();
        orangesCategory.setName("Oranges");
        Category plumsCategory = new Category();
        plumsCategory.setName("Plums");
        Category pumpkinCategory = new Category();
        pumpkinCategory.setName("Pumpkins");
        Category bananasCategory = new Category();
        bananasCategory.setName("Bananas");
        
        categoryFacade.create(applesCategory);
        categoryFacade.create(orangesCategory);
        categoryFacade.create(plumsCategory);
        categoryFacade.create(pumpkinCategory);
        categoryFacade.create(bananasCategory);
        
        int[] range = {2, 4};
        
        // when
        List<Category> foundCategories = categoryFacade.findRange(range);
        
        // then
        assertNotNull(foundCategories);
        assertEquals(2, foundCategories.size());
        assertFalse(foundCategories.contains(applesCategory));
        assertFalse(foundCategories.contains(orangesCategory));
        assertTrue(foundCategories.contains(plumsCategory));
        assertEquals(0, foundCategories.indexOf(plumsCategory));
        assertTrue(foundCategories.contains(pumpkinCategory));
        assertEquals(1, foundCategories.indexOf(pumpkinCategory));
        assertFalse(foundCategories.contains(bananasCategory));
        
        // clean up
        // ocisti sve kategorije
        // ovo moze u Before
        allCategories = categoryFacade.findAll();
        for (Category category : allCategories) {
            categoryFacade.remove(category);
        }
        container.close();

    }

    /**
     * Test of count method, of class CategoryFacade.
     */
    @Test
    public void testCount() throws Exception {
        System.out.println("count");
        EJBContainer container = javax.ejb.embeddable.EJBContainer.createEJBContainer();
        CategoryFacade instance = (CategoryFacade)container.getContext().lookup("java:global/classes/CategoryFacade");
        int expResult = 0;
        int result = instance.count();
        assertEquals(expResult, result);
        container.close();

    }
    
}
