import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class AddTwoItemsTest {

	private AffableBeanWebUI webUI;

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		webUI = new AffableBeanWebUI();
	}
	
	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		webUI.dispose();
	}

	@Test
	public void AddTwoFirstBakeryItemTest() {
		
		webUI.getWelcomePage().chooseBakery();
		webUI.getCategoryPage().addItemToCart(0);
		webUI.getCategoryPage().addItemToCart(1);
		
		webUI.getCategoryPage().viewCart();
		String message = webUI.getCartPage().getCartMessage();
		
		assertArrayEquals("Your shopping cart contains 2 items.".toCharArray(), message.toCharArray());
	}
	
	@Test
	public void AddTwoFirstDairyItemTest() {
		
		webUI.getWelcomePage().chooseDairy();
		webUI.getCategoryPage().addItemToCart(0);
		webUI.getCategoryPage().addItemToCart(1);
		
		webUI.getCategoryPage().viewCart();
		String message = webUI.getCartPage().getCartMessage();
		
		assertArrayEquals("Your shopping cart contains 2 items.".toCharArray(), message.toCharArray());
	}
	
	@Test
	public void AddTwoFirstMeatsItemTest() {
		
		webUI.getWelcomePage().chooseMeats();
		webUI.getCategoryPage().addItemToCart(0);
		webUI.getCategoryPage().addItemToCart(1);
		
		webUI.getCategoryPage().viewCart();
		String message = webUI.getCartPage().getCartMessage();
		
		assertArrayEquals("Your shopping cart contains 2 items.".toCharArray(), message.toCharArray());
	}
	
	@Test
	public void AddTwoFirstFruitAndVegItemTest() {
		
		webUI.getWelcomePage().chooseFruitAndVeg();
		webUI.getCategoryPage().addItemToCart(0);
		webUI.getCategoryPage().addItemToCart(1);
				
		webUI.getCategoryPage().viewCart();
		String message = webUI.getCartPage().getCartMessage();
		
		assertArrayEquals("Your shopping cart contains 2 items.".toCharArray(), message.toCharArray());
	}



}
