import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.chrome.ChromeDriver;

public class AffableBeanWebUI {

	private WelcomePage welcomePage;
	private CategoryPage categoryPage;
	private CartPage cartPage;
	private CheckoutPage checkoutPage;
	private ConfirmationPage confirmationPage;
	
	private WebDriver webDriver;
	
	public AffableBeanWebUI()
	{
		System.setProperty("webdriver.chrome.driver",
	 	           "C:\\Selenium\\chromedriver_win32\\chromedriver.exe");
		
		webDriver = new ChromeDriver();
		
		//webDriver.get("http://services.netbeans.org/AffableBean/");
		webDriver.get("http://localhost:8080/AffableBean/");
		
		
		welcomePage = new WelcomePage(webDriver);
		categoryPage = new CategoryPage(webDriver);
		cartPage = new CartPage(webDriver);
		checkoutPage = new CheckoutPage(webDriver);
		confirmationPage = new ConfirmationPage(webDriver);
	}
	
	public WelcomePage getWelcomePage() { return welcomePage; }
	public CategoryPage getCategoryPage() { return categoryPage; }
	public CartPage getCartPage() { return cartPage; }
	public CheckoutPage getCheckoutPage() { return checkoutPage; }
	public ConfirmationPage getConfirmationPage() { return confirmationPage; }
	
	public static void main(String[] args) {
		
		AffableBeanWebUI ui = new AffableBeanWebUI();

		try {
		
			
			//System.out.println(ui.getWelcomePage().getPageTitle());
			
			ui.getWelcomePage().chooseDairy();
			
			//ui.getWelcomePage().chooseMeats();
			
			//ui.getWelcomePage().chooseBakery();
			
			//ui.getWelcomePage().chooseFruitAndVeg();
			
			//System.out.println(ui.categoryPage.getSelectedCategory());
			
			//ui.getCategoryPage().selectDairy();
			
			ui.getCategoryPage().selectMeats();
			ui.getCategoryPage().addItemToCart(0);
			ui.getCategoryPage().addItemToCart(1);
			
			//ui.getCategoryPage().selectBakery();
			ui.getCategoryPage().addItemToCart(1);
			ui.getCategoryPage().addItemToCart(3);
			ui.getCategoryPage().viewCart();
			ui.getCartPage().updateItemQuantity(1, 3);
			//ui.getCategoryPage().selectFruitAndVeg();		
			
			
			//ui.getCartPage().getWebDriver().wait(10);
			
			//ui.getCartPage().clearCart();
			ui.getCartPage().continueShopping();
			
			//System.out.println(ui.getCartPage().getCartMessage());
			//ui.getConfirmationPage().checkOrderConfirmed("Your order has been successfully processed and will be delivered within 24 hours.");
			//ui.getCategoryPage().proceedToCheckout();
			//ui.getCartPage().proceedToCheckout();
			ui.dispose();
		
		} catch (Exception e) {
				ui.dispose();
			
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
//*/	
	
	public void dispose(){
		
		webDriver.close();
	}

}
