import java.util.List;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;

public class CartPage extends BasePage {
	
	public CartPage(WebDriver driver) {
		super(driver);
	}
	
	public void clearCart()
	{
		WebDriver driver = getWebDriver();
		driver.findElement(By.linkText("clear cart")).click();
	}
	
	public void continueShopping()
	{
		WebDriver driver = getWebDriver();
		driver.findElement(By.linkText("continue shopping")).click();
	}

	public void updateItemQuantity(int index, int quantity)
	{
		WebDriver driver = getWebDriver();
		List<WebElement> items = driver.findElements(By.name("quantity"));
		
		items.get(index).clear();
		items.get(index).sendKeys(Integer.toString(quantity));
		items.get(index).submit();
	}
	
	public String getCartMessage()
	{
		WebDriver driver = getWebDriver();
		return driver.findElement(By.id("singleColumn")).findElement(By.tagName("p")).getText();
	}
	
	public String getFirstProductImageAltAttribute()
	{
		WebDriver driver = getWebDriver();
		//return driver.findElement(By.id("singleColumn")).findElement(By.className("lightBlue")).getText();
		//return driver.findElement(By.className("lightBlue")).findElement(By.cssSelector("a[src='img/products/milk.png']"));
		//return driver.findElement(By.cssSelector("a[src='img/products/milk.png']"));
		
		return driver.findElement(By.id("cartTable")).findElement(By.tagName("img")).getAttribute("alt");
		
	}
	
	public void proceedToCheckout()
	{
		WebDriver driver = getWebDriver();
		driver.findElement(By.linkText("proceed to checkout")).click();
	}
}
