import java.util.List;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;

public class CategoryPage extends BasePage {
	
	public CategoryPage(WebDriver driver) {
		super(driver);
	}

	public String getSelectedCategory()
	{
		WebDriver driver = getWebDriver();
		return driver.findElement(By.id("selectedCategory")).getText();
	}
	
	private List<WebElement> getCategories()
	{
		WebDriver driver = getWebDriver();
		List<WebElement> categories = driver.findElements(By.className("categoryButton"));
		
		return categories;
	}
	
	public void selectDairy()
	{
		List<WebElement> categories = getCategories();
		String selectedCategory = getSelectedCategory();
		
		if(!selectedCategory.equals("dairy"))
			categories.get(0).click();
	}
	
	public void selectMeats()
	{
		List<WebElement> categories = getCategories();
		String selectedCategory = getSelectedCategory();
		
		if(!selectedCategory.equals("meats"))
			categories.get(1).click();
	}
	
	public void selectBakery()
	{
		List<WebElement> categories = getCategories();
		String selectedCategory = getSelectedCategory();
		
		if(!selectedCategory.equals("bakery"))
			categories.get(2).click();
	}
	
	public void selectFruitAndVeg()
	{
		List<WebElement> categories = getCategories();
		String selectedCategory = getSelectedCategory();
		
		if(!selectedCategory.equals("fruit & veg"))
			categories.get(3).click();
	}
	
	public String getCategoryTitle()
	{	
		WebDriver driver = getWebDriver();
		return driver.findElement(By.id("selectedCategory")).getText();
	}
	
	public void addItemToCart(int index)
	{
		WebDriver driver = getWebDriver();
		List<WebElement> items = driver.findElements(By.name("productId"));
		items.get(index).submit();
	}
	
	public void viewCart()
	{
		WebDriver driver = getWebDriver();
		driver.findElement(By.linkText("view cart")).click();
	}
	
	public void proceedToCheckout()
	{
		WebDriver driver = getWebDriver();
		driver.findElement(By.linkText("proceed to checkout")).click();
	}

}
