import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class ChooseCorrectCategoryTest {

	private AffableBeanWebUI webUI;

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		webUI = new AffableBeanWebUI();
	}
	
	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		webUI.dispose();
	}

	@Test
	public void chooseDairyTest() {
		
		webUI.getWelcomePage().chooseDairy();
		String message = webUI.getCategoryPage().getCategoryTitle();
		
		assertArrayEquals("dairy".toCharArray(), message.toCharArray());
	}
	
	@Test
	public void chooseMeatsTest() {
		
		webUI.getWelcomePage().chooseMeats();
		String message = webUI.getCategoryPage().getCategoryTitle();
		
		assertArrayEquals("meats".toCharArray(), message.toCharArray());
	}
	
	@Test
	public void chooseBakeryTest() {
		
		webUI.getWelcomePage().chooseBakery();
		String message = webUI.getCategoryPage().getCategoryTitle();
		
		assertArrayEquals("bakery".toCharArray(), message.toCharArray());
	}
	
	@Test
	public void chooseFruitAndVegTest() {
		
		webUI.getWelcomePage().chooseFruitAndVeg();
		String message = webUI.getCategoryPage().getCategoryTitle();
		
		assertArrayEquals("fruit & veg".toCharArray(), message.toCharArray());
	}

}